"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("antd/es/radio/style");

var _radio = _interopRequireDefault(require("antd/es/radio"));

require("antd/es/form/style");

var _form = _interopRequireDefault(require("antd/es/form"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("antd/es/input/style");

var _input = _interopRequireDefault(require("antd/es/input"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var FormItem = function FormItem(props) {
  /** 定义状态数据 */
  var _useState = (0, _react.useState)(null),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      form = _useState2[0],
      setForm = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      fieldData = _useState4[0],
      setFieldData = _useState4[1];

  var _useState5 = (0, _react.useState)("basic"),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      type = _useState6[0],
      setType = _useState6[1];

  var _useState7 = (0, _react.useState)(),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      itemKey = _useState8[0],
      setItemKey = _useState8[1];

  var _useState9 = (0, _react.useState)(null),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      layout = _useState10[0],
      setLayout = _useState10[1];
  /** 初始化状态 */


  (0, _react.useEffect)(function () {
    if (props && props.form) {
      setForm(props.form);
    }

    if (props && props.fieldData) {
      setFieldData(props.fieldData);
    }

    if (props && props.type) {
      setType(props.type);
      setLayout(props.type == "basic" ? {
        labelCol: {
          span: 4
        },
        wrapperCol: {
          span: 19
        }
      } : {
        labelCol: {
          span: 3
        }
      });
    }

    setItemKey(props.itemKey);
  }, []);
  var bQLineEdit = fieldData.widget == "QLineEdit";
  var bRequired = type == "basic" ? true : false;
  /**条件渲染,根据JSON中的input对象,生成对应的JSX.Element */

  var formItemJSX = bQLineEdit ? /*#__PURE__*/_react["default"].createElement(_form["default"].Item, (0, _extends2["default"])({}, layout, {
    colon: bRequired,
    label: fieldData.name,
    name: itemKey,
    initialValue: fieldData === null || fieldData === void 0 ? void 0 : fieldData.defaultVal,
    rules: [{
      required: bRequired,
      message: "".concat(fieldData.name, "\u662F\u5FC5\u586B\u9879")
    }, {
      validator: function () {
        var _validator = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(rule, values, callback) {
          var reg1, reg;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(fieldData.rule && fieldData.rule.lowVal && fieldData.rule.highVal)) {
                    _context.next = 3;
                    break;
                  }

                  if (!(parseInt(values) < parseInt(fieldData.rule.lowVal) || parseInt(values) > parseInt(fieldData.rule.highVal))) {
                    _context.next = 3;
                    break;
                  }

                  return _context.abrupt("return", Promise.reject(fieldData.name + "范围:" + fieldData.rule.lowVal + "~" + fieldData.rule.highVal));

                case 3:
                  if (!(fieldData.outputType == "float" || fieldData.outputType == "double")) {
                    _context.next = 13;
                    break;
                  }

                  reg1 = new RegExp("^(([^0][0-9]+|0).([0-9]+)$)|^(([^0][0-9]+|0)$)|^(([1-9]+).([0-9]+)$)|^(([1-9]+)$)");

                  if (!(!isNaN(parseFloat(values)) && isFinite(values) && reg1.test(values) && values[-1] != ".")) {
                    _context.next = 10;
                    break;
                  }

                  if (!(values.length != 1 && values.indexOf(".") == -1 && values[0] == "0")) {
                    _context.next = 8;
                    break;
                  }

                  return _context.abrupt("return", Promise.reject(fieldData.name + "为数字类型"));

                case 8:
                  _context.next = 11;
                  break;

                case 10:
                  return _context.abrupt("return", Promise.reject(fieldData.name + "为数字类型"));

                case 11:
                  _context.next = 19;
                  break;

                case 13:
                  if (!(fieldData.outputType == "int")) {
                    _context.next = 19;
                    break;
                  }

                  reg = new RegExp("^(0|[1-9][0-9]*)$");

                  if (!(!isNaN(parseInt(values)) && isFinite(values) && reg.test(values))) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 19;
                  break;

                case 18:
                  return _context.abrupt("return", Promise.reject(fieldData.name + "为整数类型"));

                case 19:
                  return _context.abrupt("return", Promise.resolve());

                case 20:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function validator(_x, _x2, _x3) {
          return _validator.apply(this, arguments);
        }

        return validator;
      }()
    }]
  }), /*#__PURE__*/_react["default"].createElement(_input["default"], {
    placeholder: fieldData.about
  })) : /*#__PURE__*/_react["default"].createElement(_form["default"].Item, (0, _extends2["default"])({}, layout, {
    colon: bRequired,
    label: fieldData.name,
    name: itemKey,
    initialValue: fieldData === null || fieldData === void 0 ? void 0 : fieldData.defaultVal
  }), /*#__PURE__*/_react["default"].createElement(_radio["default"].Group, null, fieldData && fieldData.maps && fieldData.maps.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(_radio["default"], {
      key: option.value,
      value: option.value
    }, option.name);
  })));
  return formItemJSX;
};

var _default = FormItem;
exports["default"] = _default;